
/* sample program to convert GRAFTAL string to x,y coordinates            */
/*                                                                        */
/* invoke program with "graftal <limit>" where limit is number of symbols */
/*   to be scanned;  default for <limit>  is 200                          */ 
/* output of program is:  branch level   x coord     y coord              */   

#include <\c88\stdio.h>
FILE *ingrf;
int x,y,p;
int brlev = 0;
int limit;
main(argc, argv)
 int argc;
 char *argv[];
{

 ingrf   = fopen("graftal.dat","r");
 if(ingrf == NULL) exit(0);

 limit = atoi(argv[1]); 
 if (limit == 0) limit = 200;

  while ( (p = mfgetc(ingrf)) != EOF) 
{
    if (p == '0') grow(&x,&y,1);
    if (p == '1') grow(&x,&y,1);
    if (p =='[')  branch(x,y,1);
 }
}

grow(lx,ly,dir)
int *lx,*ly,dir;
{ 
  int sign;
  do 
    { if( p == '0' || p == '1') 
     {
       if (p == '0') 
         sign = -1;   
       else          
         sign = 1;
       if (dir == 1) 
         {
         *lx = (*lx + sign); 
          printf(" %2d %3d %3d\n",brlev,*lx,*ly);
          }
       else
         {
         *ly = (*ly + sign); 
          printf(" %2d %3d %3d\n",brlev,*lx,*ly);
          }
      }
       if (p =='[') 
         {   
          if (dir == 1 ) 
             branch(*lx,*ly,0); 
          else
             branch(*lx,*ly,1);
          }
      } while ( (p = mfgetc(ingrf)) != ']' && p != EOF );
}
int branch(x,y,dir) 
  int x,y,dir;
{ int lx,ly;
  lx =x;
  ly =y;
  brlev++;
  p = mfgetc(ingrf); 
  {
  if (p == '0' || p == '1') grow(&lx,&ly,dir);
  if (p == '[') 
   {
   if (dir == 1) 
     branch(lx,ly,0); 
   else
     branch(lx,ly,1);
   }
   if ( p == ']'  || p == EOF)  return(--brlev);}
}
int mfgetc(fp)
FILE *fp;
{ 
static int count = 0;
if(++count > limit) return(EOF);
else
return(fgetc(fp));
}